// Filename           : CLICTD_environment.sv
// Author             : Núria Egidos 
// Created on         : 4/6/18
// Last modification  : 27/9/18
// Project            : Doctoral student, verification of CLICTD
// Description        : Environment
// Derived from       : analysis_custom_env.sv and top_env.sv by Elia Conti and Sara Marconi for VEPIX53 


// http://www.chipverify.com/uvm/tlm-analysis-port


`ifndef __CLICTD_environment_sv__
`define __CLICTD_environment_sv__



class CLICTD_environment extends uvm_env;


	// Declare all possible agents. In the build_phase, we will
  // only create those indicated by the configuration object
  CLICTD_slowcontrol_agent slowcontrol_agent;
  CLICTD_regslowcontrol_agent regslowcontrol_agent;
  CLICTD_dataout_agent dataout_agent;
  CLICTD_pins_agent pins_agent;

  // Declare all possible scoreboards. In the build phase, we will
  // only create those indicated by the configuration object
  CLICTD_regslowcontrol_scoreboard regslowcontrol_scoreboard;
  CLICTD_dataout_scoreboard dataout_scoreboard;
  CLICTD_pins_scoreboard pins_scoreboard;

  // Declare a cross-coverage collector. In the build phase, we will
  // only create it if indicated by the configuration object
  //CLICTD_crosscoverage_collector crosscoverage_collector;

  // Environment configuration object; this is created by the test and stored
  // in the configuration database, it is retrieved in the build phase of the environment
  CLICTD_environment_config env_config;


  // Matrix model, the block that provides the expected value of pins and dataout fields
  // to pins_model and dataout_model
  CLICTD_matrix_model matrix_model;

  // Block that filters the transactions coming from the regslowcontrol_monitor
  // so as to propagate only those corresponding to a read operation towards
  // the regslowcontrol_comparator. The purpose of such filtering is that these
  // transactions are to be compared by those generated by the regslowcontrol_model,
  // which were built with the content of the transactions corresponding to a write
  // operation on some slow control registers. 
  // By filtering, we make sure that the same amount of transactions coming from
  // the monitor and from the model reach the comparator
  CLICTD_readpass_transaction_filter readpass_transaction_filter;

  // By declaring the fields like below, these scoreboards will be accessible from
  // all the factory components instantiated in the test framework
  `uvm_component_utils_begin( CLICTD_environment ) // Register the component to the factory
      `uvm_field_object( env_config, UVM_DEFAULT | UVM_REFERENCE )
   `uvm_component_utils_end
  // With this macro:
   // -	UVM_DEFAULT (or UVM_ALL_ON) indicates that env_config, etc. will be available for all components and methods
   // -	UVM_REFERENCE indicates that when env_config, etc. are used in some of the components below CLICTD_reset_test, 
   //   they don't need to be created, but they point directly to the instances in CLICTD_reset_test. 
   //   Therefore, if they're used in more than one place, all actions modify the instances in CLICTD_reset_test, and 
   //   the changes are seen by all the blocks that contain env_config, etc. references.
   // https://verificationacademy.com/verification-methodology-reference/uvm/docs_1.1c/html/files/macros/uvm_object_defines-svh.html 

	// Constructor
  function new(string name, uvm_component parent);
	  super.new(name, parent);
  endfunction: new


	// Build phase: build the hierarchy
	virtual function void build_phase(uvm_phase phase);
		super.build_phase(phase);
		//
    if( !uvm_config_db#(CLICTD_environment_config)::get(this, "", "env_config", env_config) )
       `uvm_error( `NOCONFIG_ENV, $sformatf("Environment configuration not found in database for %s", this.get_full_name()) )
		else begin
        slowcontrol_agent = CLICTD_slowcontrol_agent::type_id::create( .name("slowcontrol_agent"), .parent(this) );
				regslowcontrol_agent = CLICTD_regslowcontrol_agent::type_id::create( .name("regslowcontrol_agent"), .parent(this) );
        dataout_agent = CLICTD_dataout_agent::type_id::create( .name("dataout_agent"), .parent(this) );
				pins_agent = CLICTD_pins_agent::type_id::create( .name("pins_agent"), .parent(this) );

        matrix_model = CLICTD_matrix_model::type_id::create( .name("matrix_model"), .parent(this) );
        readpass_transaction_filter = CLICTD_readpass_transaction_filter::type_id::create( .name("readpass_transaction_filter"), .parent(this) );
				  
				regslowcontrol_scoreboard = CLICTD_regslowcontrol_scoreboard::type_id::create( .name("regslowcontrol_scoreboard"), .parent(this) );
        dataout_scoreboard = CLICTD_dataout_scoreboard::type_id::create( .name("dataout_scoreboard"), .parent(this) );
        pins_scoreboard = CLICTD_pins_scoreboard::type_id::create( .name("pins_scoreboard"), .parent(this) );
          
				
		 end // else (env_config != null)
  	//    
  endfunction: build_phase
       

	// Connect phase: connect ports and exports
	function void connect_phase(uvm_phase phase);
		super.connect_phase(phase);
    // Connect the analysis ports of the agents (which are connected to the analysis
    // ports of the monitors beneath) to the analysis exports of the scoreboards
		//

    regslowcontrol_agent.analysis_port.connect(readpass_transaction_filter.analysis_export);
    readpass_transaction_filter.analysis_port.connect(regslowcontrol_scoreboard.analysis_export_out);
    regslowcontrol_agent.analysis_port.connect(regslowcontrol_scoreboard.analysis_export_in);
		
    dataout_agent.analysis_port.connect(dataout_scoreboard.analysis_export_out);
    dataout_agent.analysis_port.connect(dataout_scoreboard.analysis_export_in);

    regslowcontrol_agent.analysis_port.connect(matrix_model.analysis_export);
    matrix_model.analysis_port_pins.connect(pins_scoreboard.analysis_export_matrix);
    matrix_model.analysis_port_dataout.connect(dataout_scoreboard.analysis_export_matrix);
		
    pins_agent.analysis_port.connect(pins_scoreboard.analysis_export_out);
    pins_agent.analysis_port.connect(pins_scoreboard.analysis_export_in);

    

	
		//
	endfunction: connect_phase


endclass: CLICTD_environment

`endif // __CLICTD_environment_sv__

